---
title: Document.evaluate()
slug: Web/API/Document/evaluate
tags:
  - API
  - DOM
  - Method
  - Reference
  - XPath
---
<div>{{ ApiRef("DOM") }}</div>

<p>Returns an {{domxref("XPathResult")}} based on an <a href="/en-US/docs/XPath" title="XPath">XPath</a> expression and other given parameters.</p>

<h2 id="Syntax">Syntax</h2>

<pre class="syntaxbox">var xpathResult = document.evaluate(
  xpathExpression,
  contextNode,
  namespaceResolver,
  resultType,
  result
);</pre>

<ul>
	<li><code>xpathExpression</code> is a string representing the XPath to be evaluated.</li>
	<li><code>contextNode</code> specifies the <em>context node</em> for the query (see the <a class="external" href="http://www.w3.org/TR/xpath" rel="freelink">XPath specification</a>). It's common to pass <code>document</code> as the context node.</li>
	<li><code>namespaceResolver</code> is a function that will be passed any namespace prefixes and should return a string representing the namespace URI associated with that prefix. It will be used to resolve prefixes within the XPath itself, so that they can be matched with the document. <code>null</code> is common for HTML documents or when no namespace prefixes are used.</li>
	<li><code>resultType</code> is an integer that corresponds to the type of result <code>XPathResult</code> to return. Use <a href="#Result_types">named constant properties</a>, such as <code>XPathResult.ANY_TYPE</code>, of the XPathResult constructor, which correspond to integers from 0 to 9.</li>
	<li><code>result</code> is an existing <code>XPathResult</code> to use for the results. <code>null</code> is the most common and will create a new <code>XPathResult</code></li>
</ul>

<h2 id="Example">Example</h2>

<pre class="brush: js">var headings = document.evaluate("/html/body//h2", document, null, XPathResult.ANY_TYPE, null);
/* Search the document for all h2 elements.
 * The result will likely be an unordered node iterator. */
var thisHeading = headings.iterateNext();
var alertText = "Level 2 headings in this document are:\n";
while (thisHeading) {
  alertText += thisHeading.textContent + "\n";
  thisHeading = headings.iterateNext();
}
alert(alertText); // Alerts the text of all h2 elements
</pre>

<p>Note, in the above example, a more verbose XPath is preferred over common shortcuts such as <code>//h2</code>. Generally, more specific XPath selectors as in the above example usually gives a significant performance improvement, especially on very large documents. This is because the evaluation of the query spends does not waste time visiting unnecessary nodes. Using // is generally slow as it visits <em>every</em> node from the root and all subnodes looking for possible matches.</p>

<p>Further optimization can be achieved by careful use of the context parameter. For example, if you know the content you are looking for is somewhere inside the body tag, you can use this:</p>

<pre class="brush: js">document.evaluate(".//h2", document.body, null, XPathResult.ANY_TYPE, null);
</pre>

<p>Notice in the above <code>document.body</code> has been used as the context instead of <code>document</code> so the XPath starts from the body element. (In this example, the <code>"."</code> is important to indicate that the querying should start from the context node, document.body. If the "." was left out (leaving <code>//h2</code>) the query would start from the root node (<code>html</code>) which would be more wasteful.)</p>

<p>See <a href="/en-US/docs/Introduction_to_using_XPath_in_JavaScript" title="Introduction to using XPath in JavaScript">Introduction to using XPath in JavaScript</a> for more information.</p>

<h2 id="Notes">Notes</h2>

<ul>
	<li>XPath expressions can be evaluated on HTML and XML documents.</li>
	<li>While using document.evaluate() works in FF2, in FF3 one must use someXMLDoc.evaluate() if evaluating against something other than the current document.</li>
</ul>

<h2 id="Result_types">Result types</h2>

<p>(Merge with <a href="/Template:XPathResultConstants" title="Template:XPathResultConstants">Template:XPathResultConstants</a>?</p>

<p>These are supported values for the <code>resultType</code> parameter of the <code>evaluate</code> method:</p>

<table class="standard-table">
	<tbody>
		<tr>
			<td class="header">Result Type</td>
			<td class="header">Value</td>
			<td class="header">Description</td>
		</tr>
		<tr>
			<td><code>ANY_TYPE</code></td>
			<td>0</td>
			<td>Whatever type naturally results from the given expression.</td>
		</tr>
		<tr>
			<td><code>NUMBER_TYPE</code></td>
			<td>1</td>
			<td>A result set containing a single number. Useful, for example, in an XPath expression using the <code>count()</code> function.</td>
		</tr>
		<tr>
			<td><code>STRING_TYPE</code></td>
			<td>2</td>
			<td>A result set containing a single string.</td>
		</tr>
		<tr>
			<td><code>BOOLEAN_TYPE</code></td>
			<td>3</td>
			<td>A result set containing a single boolean value. Useful, for example, an XPath expression using the <code>not()</code> function.</td>
		</tr>
		<tr>
			<td><code>UNORDERED_NODE_ITERATOR_TYPE</code></td>
			<td>4</td>
			<td>A result set containing all the nodes matching the expression. The nodes in the result set are not necessarily in the same order they appear in the document.</td>
		</tr>
		<tr>
			<td><code>ORDERED_NODE_ITERATOR_TYPE</code></td>
			<td>5</td>
			<td>A result set containing all the nodes matching the expression. The nodes in the result set are in the same order they appear in the document.</td>
		</tr>
		<tr>
			<td><code>UNORDERED_NODE_SNAPSHOT_TYPE</code></td>
			<td>6</td>
			<td>A result set containing snapshots of all the nodes matching the expression. The nodes in the result set are not necessarily in the same order they appear in the document.</td>
		</tr>
		<tr>
			<td><code>ORDERED_NODE_SNAPSHOT_TYPE</code></td>
			<td>7</td>
			<td>A result set containing snapshots of all the nodes matching the expression. The nodes in the result set are in the same order they appear in the document.</td>
		</tr>
		<tr>
			<td><code>ANY_UNORDERED_NODE_TYPE</code></td>
			<td>8</td>
			<td>A result set containing any single node that matches the expression. The node is not necessarily the first node in the document that matches the expression.</td>
		</tr>
		<tr>
			<td><code>FIRST_ORDERED_NODE_TYPE</code></td>
			<td>9</td>
			<td>A result set containing the first node in the document that matches the expression.</td>
		</tr>
	</tbody>
</table>

<p>Results of <code>NODE_ITERATOR</code> types contain references to nodes in the document. Modifying a node will invalidate the iterator. After modifying a node, attempting to iterate through the results will result in an error.</p>

<p>Results of <code>NODE_SNAPSHOT</code> types are snapshots, which are essentially lists of matched nodes. You can make changes to the document by altering snapshot nodes. Modifying the document doesn't invalidate the snapshot; however, if the document is changed, the snapshot may not correspond to the current state of the document, since nodes may have moved, been changed, added, or removed.</p>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
	<thead>
		<tr>
			<th scope="col">Specification</th>
			<th scope="col">Status</th>
			<th scope="col">Comment</th>
		</tr>
	</thead>
	<tbody>
		<tr>
			<td>{{SpecName("DOM3 XPath", "xpath.html#XPathEvaluator-evaluate", "Document.evaluate")}}</td>
			<td>{{Spec2("DOM3 XPath")}}</td>
			<td>Initial specification</td>
		</tr>
	</tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("api.Document.evaluate")}}</p>

<h2 id="See_also">See also</h2>

<ul>
	<li>{{domxref("Document.createExpression()")}}</li>
	<li>{{domxref("XPathResult")}}</li>
	<li><a href="/en-US/docs/Code_snippets/XPath" title="Code_snippets/XPath">XPath Code Snippets</a></li>
	<li><a href="http://codepen.io/johan/full/ckFgn">Check for browser support</a></li>
</ul>
